/***************************************************************************
                          leif.cpp  -  description
                             -------------------
    begin                : Wed Mar  5 15:21:47 CET 2003
    copyright            : (C) 2003 by Tobias Bayer
    email                : t.bayer@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "leif.h"
#include "settingsdlg.h"
#include "newcontactdlg.h"
#include "newsms.h"
#include "sms.h"
#include "gsm.h"

#include <qvariant.h>
#include <klistview.h>
#include <kpushbutton.h>
#include <qheader.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qtoolbar.h>
#include <qimage.h>
#include <qpixmap.h>
#include <klocale.h>
#include <kconfig.h>
#include <kmessagebox.h>
#include <qbuttongroup.h>
#include <kiconloader.h>
#include <kprogress.h>
#include <kpopupmenu.h>
#include <kmenubar.h>
#include <qlineedit.h>
#include <kfiledialog.h>
#include <fstream>
#include <qregexp.h>
#include <qtextedit.h>
#include <qtimer.h>
#include <qcheckbox.h>

//Global vars

v24_port_t *port=NULL;
bool connected=FALSE;

Leif::Leif(QWidget *parent, const char *name) : KMainWindow(parent, name)
{
	srand(time(0));
  (void)statusBar();
    if ( !name )
	setName( "MainWindow" );
		communicating=false;
    setCentralWidget( new QWidget( this, "qt_central_widget" ) );
    MainWindowLayout = new QGridLayout( centralWidget(), 1, 1, 11, 6, "MainWindowLayout");

    MainTab = new QTabWidget( centralWidget(), "MainTab" );

    tab = new QWidget( MainTab, "tab" );

    textLabel1_3 = new QLabel( tab, "textLabel1_3" );
    MainTab->insertTab( tab, "" );

    tab_2 = new QWidget( MainTab, "tab_2" );
    tabLayout = new QGridLayout( tab_2, 1, 1, 11, 6, "tabLayout");

    NewButton = new KPushButton( tab_2, "NewButton" );

    tabLayout->addWidget( NewButton, 3, 0 );

    PhoneBookRadios = new QButtonGroup(tab_2);
    PhoneBookRadios->hide();
    
    PhoneRadio = new QRadioButton( tab_2, "PhoneRadio" );
    PhoneRadio->setChecked( TRUE );

    tabLayout->addWidget( PhoneRadio, 0, 0 );

    SimRadio = new QRadioButton( tab_2, "SimRadio" );

    tabLayout->addWidget( SimRadio, 1, 0 );

    PhoneBookRadios->insert(PhoneRadio);
    PhoneBookRadios->insert(SimRadio);

    ReadButton = new KPushButton( tab_2, "ReadButton" );

    tabLayout->addWidget( ReadButton, 3, 1 );

    DeleteButton = new KPushButton( tab_2, "DeleteButton" );

    tabLayout->addWidget( DeleteButton, 3, 2 );

    CallButton = new KPushButton( tab_2, "CallButton" );

    tabLayout->addWidget( CallButton, 3, 3 );

    SavePhonebookButton = new KPushButton(tab_2, "SavePhonebookButton");

    tabLayout->addWidget(SavePhonebookButton, 4, 0);

    RestorePhonebookButton = new KPushButton(tab_2, "RestorePhonebookButton");

    tabLayout->addWidget(RestorePhonebookButton, 4, 1);

    EditButton = new KPushButton(tab_2, "EditButton");

    tabLayout->addWidget(EditButton, 4, 2);

    newSMSPhonebookButton = new KPushButton(tab_2, "newSMSPhonebookButton");

    tabLayout->addWidget(newSMSPhonebookButton, 4, 3);

    PhonebookList = new KListView( tab_2, "PhonebookList" );
    PhonebookList->addColumn( tr( "#" ) );
    PhonebookList->addColumn( i18n( "Type" ) );
    PhonebookList->addColumn( i18n( "Name" ) );
    PhonebookList->addColumn( i18n( "Number" ) );
		PhonebookList->setAllColumnsShowFocus(true);
		PhonebookList->setColumnAlignment(0,Qt::AlignRight);
		PhonebookList->setColumnAlignment(1,Qt::AlignHCenter);
				
    tabLayout->addMultiCellWidget( PhonebookList, 2, 2, 0, 3 );
    MainTab->insertTab( tab_2, "" );

    tab_3 = new QWidget( MainTab, "tab_3" );

    MainTab->insertTab( tab_3, "" );

    tab_4 = new QWidget( MainTab, "tab_4" );

    MainTab->insertTab( tab_4, "" );

    MainWindowLayout->addWidget( MainTab, 0, 0 );

    // actions
    ConnectAction = new QAction( this, "ConnectAction" );
    DisconnectAction = new QAction( this, "DisconnectAction" );
    fileSettingsAction = new QAction (this, "fileSettingsAction");
    fileExitAction = new QAction( this, "fileExitAction" );



    // toolbars
    toolBar()->insertButton(BarIcon("connect_established"), 0,
      SIGNAL(clicked(int)), this, SLOT(fileConnect()));
    toolBar()->insertButton(BarIcon("connect_no"), 1,
      SIGNAL(clicked(int)), this, SLOT(fileDisconnect()));
    

    // menubar
    fileMenu = new KPopupMenu( this );

    ConnectAction->addTo( fileMenu );
    DisconnectAction->addTo( fileMenu );
    fileSettingsAction->addTo(fileMenu);
    fileMenu->insertSeparator();
    fileExitAction->addTo( fileMenu );
    menuBar()->insertItem( "", fileMenu, 0 );


    KPopupMenu *help =  helpMenu();
    menuBar()->insertItem(i18n("&Help"), help);
    

    // signals and slots connections
    connect( ConnectAction, SIGNAL( activated() ), this, SLOT( fileConnect() ) );
    connect( DisconnectAction, SIGNAL( activated() ), this, SLOT( fileDisconnect() ) );
    connect( fileSettingsAction, SIGNAL( activated() ), this, SLOT( fileSettings() ) );
    connect( fileExitAction, SIGNAL( activated() ), this, SLOT( fileExit() ) );
    connect(ReadButton, SIGNAL(clicked()), this, SLOT(readPhoneBook()));
    connect(NewButton, SIGNAL(clicked()), this, SLOT(newContact()));
    connect(DeleteButton, SIGNAL(clicked()), this, SLOT(deleteContact()));
    connect(EditButton, SIGNAL(clicked()), this, SLOT(editContactButton()));
    connect(CallButton, SIGNAL(clicked()), this, SLOT(callContact()));
    connect(newSMSPhonebookButton, SIGNAL(clicked()), this, SLOT(newSMS()));
    connect(SavePhonebookButton, SIGNAL(clicked()), this, SLOT(savePhonebook()));
    connect(RestorePhonebookButton, SIGNAL(clicked()), this, SLOT(restorePhonebook()));
    connect(PhonebookList, SIGNAL(doubleClicked(QListViewItem*)), this, SLOT(editContact(QListViewItem*)));
    
    //Captions
    MainTab->changeTab( tab, i18n( "&General" ) );
    NewButton->setText( i18n( "&New" ) );
    PhoneRadio->setText( i18n( "Ph&one" ) );
    SimRadio->setText( i18n( "S&IM" ) );
    ReadButton->setText( i18n( "&Read" ) );
    DeleteButton->setText( i18n( "&Delete" ) );
    EditButton->setText( i18n( "&Edit" ) );
    CallButton->setText( i18n( "&Call" ) );
    newSMSPhonebookButton->setText(i18n("Ne&w SMS"));
    SavePhonebookButton->setText(i18n("Sa&ve"));
    RestorePhonebookButton->setText(i18n("R&estore"));
    PhonebookList->header()->setLabel( 0, i18n( "#" ) );
    PhonebookList->header()->setLabel( 1, i18n( "Type" ) );
    PhonebookList->header()->setLabel( 2, i18n( "Name" ) );
    PhonebookList->header()->setLabel( 3, i18n( "Number" ) );
    MainTab->changeTab( tab_2, i18n( "Phone&book" ) );
    MainTab->changeTab( tab_3, i18n( "&SMS" ) );
    MainTab->changeTab( tab_4, i18n( "&Upload" ) );
    ConnectAction->setText( i18n( "Connect" ) );
    ConnectAction->setMenuText( i18n( "&Connect" ) );
    ConnectAction->setAccel( tr( "Ctrl+C" ) );
    DisconnectAction->setText( i18n( "Disconnect" ) );
    DisconnectAction->setMenuText( i18n( "&Disconnect" ) );
    DisconnectAction->setAccel( tr( "Ctrl+D" ) );
    fileSettingsAction->setText(i18n("Settings"));
    fileSettingsAction->setMenuText(i18n("&Settings"));
    fileSettingsAction->setAccel(tr("Ctrl+S"));
    fileExitAction->setText( i18n( "Exit" ) );
    fileExitAction->setMenuText( i18n( "E&xit" ) );
    fileExitAction->setAccel( QString::null );

    menuBar()->findItem( 0 )->setText( i18n( "&Phone" ) );

    tabLayout_2 = new QGridLayout( tab, 1, 1, 11, 6, "tabLayout_2");

    textLabel3_4 = new QLabel( tab, "textLabel3_4" );
    tabLayout_2->addWidget( textLabel3_4, 1, 0 );

    charge = new KProgress( tab, "charge" );
    charge->setRange(0,100);
    charge->setValue(0);
    tabLayout_2->addWidget( charge, 1,1 );
    
    textLabel3_4->setText(i18n("Battery charge:"));

    textLabel3_5 = new QLabel( tab, "textLabel3_5" );
    textLabel3_5->setText(i18n("Signal quality:"));
    tabLayout_2->addWidget( textLabel3_5, 2, 0 );

    signal = new KProgress( tab, "signal" );
    signal->setRange(0,31);
    signal->setValue(0);
    tabLayout_2->addWidget( signal, 2,1 );

    textLabel2 = new QLabel(tab);
    textLabel2->setText(i18n("State:"));
    tabLayout_2->addWidget(textLabel2, 0, 0);

    connectStateLabel = new QLabel(tab);
    connectStateLabel->setText(i18n("Disconnected"));
    tabLayout_2->addWidget(connectStateLabel,0,1);

    generalRefreshButton = new KPushButton(tab);
    tabLayout_2->addWidget(generalRefreshButton,3,1);
    generalRefreshButton->setText(i18n("&Refresh"));
    connect(generalRefreshButton, SIGNAL(clicked()), this, SLOT(refreshGeneral()));

    syncDateTimeButton = new KPushButton(tab);
    tabLayout_2->addWidget(syncDateTimeButton, 4,1);
    syncDateTimeButton->setText(i18n("Sync &date and time"));
    connect(syncDateTimeButton, SIGNAL(clicked()), this, SLOT(syncDateTime()));

    silentCheckBox = new QCheckBox(tab);
    tabLayout_2->addWidget(silentCheckBox, 5, 1);
    silentCheckBox->setText(i18n("S&ilent"));
    connect(silentCheckBox, SIGNAL(clicked()), this, SLOT(setSilentMode()));

    tabLayout_2->setRowStretch(1,2);


/*Upload Tab*/
    uploadTabLayout = new QGridLayout(tab_4,1,1,11,6);

    obexLocalFileLabel = new QLabel(tab_4);
    obexLocalFileLabel->setText(i18n("File to upload:"));
    uploadTabLayout->addWidget(obexLocalFileLabel,0,0);

    uploadTabLayout->setRowStretch(0,2);
    uploadTabLayout->setRowStretch(1,2);    
    
    obexLocalFileEdit = new QLineEdit(tab_4);
    uploadTabLayout->addWidget(obexLocalFileEdit,0,1);
    connect(obexLocalFileEdit, SIGNAL(textChanged(const QString &)), this, SLOT(updateRemoteFileName(const QString &)));
    
    obexBrowseFileButton = new KPushButton(tab_4);
    obexBrowseFileButton->setText("...");
    uploadTabLayout->addWidget(obexBrowseFileButton, 0,2);
    connect(obexBrowseFileButton, SIGNAL(clicked()), this, SLOT(browseUploadFile()));

    obexRemoteFileLabel = new QLabel(tab_4);
    obexRemoteFileLabel->setText(i18n("Name on phone:"));
    uploadTabLayout->addWidget(obexRemoteFileLabel,1,0);

    obexRemoteFileEdit = new QLineEdit(tab_4);
    uploadTabLayout->addWidget(obexRemoteFileEdit,1,1);

    obexSendButton = new KPushButton(tab_4);
    obexSendButton->setText(i18n("Up&load"));
    uploadTabLayout->addWidget(obexSendButton,2,1);
    connect(obexSendButton, SIGNAL(clicked()), this, SLOT(sendFile()));


/*SMS Tab*/
    smsTabLayout = new QGridLayout(tab_3,1,1,11,6);

    smsList = new KListView(tab_3);
    smsList->addColumn(tr("#"));
    smsList->addColumn(i18n("Status"));
    smsList->addColumn(i18n("From/To"));
    smsList->addColumn(i18n("Message"));
    smsList->addColumn(i18n("Phone Number"));
    smsList->setColumnWidth(4,0);
		smsList->setAllColumnsShowFocus(true);
    smsTabLayout->addMultiCellWidget(smsList,0,4,0,3);
    smsTabLayout->setRowStretch(0,3);
		smsList->setColumnAlignment(0,Qt::AlignRight);
		smsList->setColumnAlignment(1,Qt::AlignHCenter);

    retrieveSMSListButton = new KPushButton(tab_3);
    retrieveSMSListButton->setText(i18n("&Retrieve List"));
    smsTabLayout->addWidget(retrieveSMSListButton, 5,0);
    
    newSMSButton = new KPushButton(tab_3);
    newSMSButton->setText(i18n("&New SMS"));
    smsTabLayout->addWidget(newSMSButton, 5,1);

    deleteSMSButton = new KPushButton(tab_3);
    deleteSMSButton->setText(i18n("&Delete SMS"));
    smsTabLayout->addWidget(deleteSMSButton, 5,2);

    deleteAllSMSButton = new KPushButton(tab_3);
    deleteAllSMSButton->setText(i18n("Delete &All SMS"));
    smsTabLayout->addWidget(deleteAllSMSButton, 5, 3);

    connect(newSMSButton, SIGNAL(clicked()), this, SLOT(newSMS()));
    connect(retrieveSMSListButton, SIGNAL(clicked()), this, SLOT(retrieveSMSList()));
    connect(deleteSMSButton, SIGNAL(clicked()), this, SLOT(deleteSMS()));
    connect(smsList, SIGNAL(doubleClicked(QListViewItem*)), this, SLOT(showCompleteSMS(QListViewItem*)));
    connect(deleteAllSMSButton, SIGNAL(clicked()), this, SLOT(deleteAllSMS()));

		// connect timer to refreshGeneral
		timer = new QTimer(this);
		connect( timer, SIGNAL(timeout()), this, SLOT(refreshGeneral()) );
		timer2 = new QTimer(this);
		connect( timer2, SIGNAL(timeout()), this, SLOT(displayIncomingSMS()) );
    // get current settings
		settingsUpdated();
		
		KConfig *settings = kapp->config();
    settings->setGroup("Main");
    if (settings->readNumEntry("ConnectStart") == 1)
      fileConnect();
     
  	KIconLoader iconLoader;
  	mobile = iconLoader.loadIcon("kppp", KIcon::Small);
  	home = iconLoader.loadIcon("kfm_home", KIcon::Small);
  	work = iconLoader.loadIcon("personal", KIcon::Small);
  	other = iconLoader.loadIcon("mime", KIcon::Small);
}


void Leif::fileConnect()
{
  communicating=true;
  port=v24OpenPort(device, V24_RTS_CTS);
	communicating=false;
  //Port opened?
  if (port==NULL)
  {
    KMessageBox::error( this, i18n("Could not open port"), i18n( "Error" ));
  }
  else
  {
    connected = TRUE;
    // mobile shall send +CMTI:mem,index message for incoming SMS
    QStringList ans = portComm(port, "at+cnmi=?\r");
    QString x=ans.join(":");
    QString mode=x.mid(x.find("("),x.find(")")-x.find("(")+1);
    if (mode.contains("2"))
    	ans = portComm(port, "at+cnmi=2,1,0,0\r");
    else if (mode.contains("3"))
    	ans = portComm(port, "at+cnmi=3,1,0,0\r");
    else printf("mobile has only %s capabilities!", (const char*)x);

    timer2->start(1000);
    settingsUpdated();
    refreshGeneral();
  }
  
}

void Leif::fileDisconnect()
{
  timer->stop();
  timer2->stop();
  v24ClosePort(port);
  communicating=false;
  connected = FALSE;
  PhonebookList->clear();
  smsList->clear();
  charge->setValue(0);
  signal->setValue(0);
  connectStateLabel->setText("Disconnected");
}

void Leif::fileSettings()
{
  SettingsDlg *settings=new SettingsDlg(this);
  settings->show();
  connect(settings, SIGNAL(settingsUpdated()), this,
    				SLOT(settingsUpdated()));  
}

void Leif::fileExit()
{
  if (connected)
    fileDisconnect();
  this->close();
}


void Leif::refreshGeneral()
{
  QStringList ans;

  if (connected)
  {
  //Set status label
  connectStateLabel->setText("Connected");

  //request battery charge
    ans = portComm(port, "at+cbc\r");

  QString batt = ans.join(":");

  //Find battery charge
  QString chargeStr = batt.mid(batt.find("+CBC")+8, 3);
  charge->setValue(chargeStr.toInt());

  //request signal quality
  ans = portComm(port, "at+csq\r");
  batt = ans.join(":");
  chargeStr = batt.mid(batt.find("+CSQ")+5,batt.find(",")-batt.find("+CSQ")-5);
  signal->setValue(chargeStr.toInt());
  }
} 

//Read the phonebook from the cellphone
void Leif::readPhoneBook()
{
  QStringList pb,ptemp;
  QString pbs, id, type, name, number, num;

  if (connected)
  {
    //set phonebook (sim or phone)
    if (SimRadio->isOn())
    {
      portComm(port, "at+cpbs=\"SM\"\r");
    }
    else
    {
      portComm(port, "at+cpbs=\"ME\"\r");
    }

    pb = portComm(port, "at-scer=1\r");
    pbs = pb.join(":");
    
    // determine maximun size of phonebook
    pb = portComm(port, "at+cpbr=?\r");
    for (QStringList::ConstIterator it = pb.begin(); it != pb.end(); ++it)
    {
      pbs.setLatin1(*it);
      if (pbs.contains("+CPBR:")) //Don't parse command echo or OK messages
      {
        //Parse string
        int i=pbs.find("-")+1;
        num = pbs.mid(i,pbs.find(")")-i);
			}
		}
		
    //read phonebook
    pb = portComm(port, "at+cpbr=1,"+num+"\r");
    
    PhonebookList->clear();

    for (QStringList::ConstIterator it = pb.begin(); it != pb.end(); ++it)
    {
      pbs.setLatin1(*it);
      pbs = convert_from_gsm(pbs);
      if (pbs.contains("+CPBR:")) //Don't parse command echo or OK messages
      {
        //Parse string
        id = pbs.mid(7,pbs.find(",")-7);
//        if (id.toInt() < 10)
//          id.prepend("0");
        type = pbs.mid(pbs.find("/")+1,1);
        number = pbs.mid(pbs.find(",")+2,pbs.find("\",")-pbs.find(",")-2);
        name = pbs.mid(pbs.findRev(",", pbs.length()-2)+2, pbs.find("/")-(pbs.findRev(",", pbs.length()-2)+2));

        if (type == "H")
        {
          QListViewItem *item = new QListViewItem(PhonebookList, id, "", name, number);
          item->setPixmap(1, home);
          PhonebookList->insertItem(item);
        }
        else if (type == "M")
        {
          QListViewItem *item = new QListViewItem(PhonebookList, id, "", name, number);
          item->setPixmap(1, mobile);
          PhonebookList->insertItem(item);
        }
        else if (type == "W")
        {
          QListViewItem *item = new QListViewItem(PhonebookList, id, "", name, number);
          item->setPixmap(1, work);
          PhonebookList->insertItem(item);
        }
        else
        {
          QListViewItem *item = new QListViewItem(PhonebookList, id, "", name, number);
          item->setPixmap(1, other);
          PhonebookList->insertItem(item);
        } 
        PhonebookList->setSorting(2);
        PhonebookList->sort();
      }
    }
  }
}

void Leif::newContact()
{                                                                                                                 
    if (connected)
    {
      NewContactDlg *newc = new NewContactDlg(this);
      QObject::connect(newc,
                                SIGNAL(sendContact(const QString&, const QString&,
                                									 const QString&, const QString&)),
                                this,
                                SLOT(createNewContact(const QString&, const QString&,
                                											const QString&, const QString&)));

      newc->show();
    }
}

void Leif::createNewContact(const QString &ind, const QString &name,
														const QString &number, const QString &type)
{
  QString command;
  
  if (ind.isEmpty())
    command = "at+cpbw=,\"";
  else
  {
    command = "at+cpbw=";
    command.append(ind);
    command.append(",\"");
  }
  command.append(number);
  command.append("\",,\"");
  command.append(convert_to_gsm(name));
  command.append("/");
  command.append(type);
  command.append("\"\r");

  portComm(port, command);

  if (ind.isEmpty())
    readPhoneBook();
  else
  {
  	QListViewItem *edited_contact=PhonebookList->findItem(ind,0);
   	if (edited_contact)
    {
     	edited_contact->setText(0,ind);
     	if (type=="H")
      	edited_contact->setPixmap(1, home);
     	else if (type=="M")
      	edited_contact->setPixmap(1, mobile);
     	else if (type=="W")
      	edited_contact->setPixmap(1, work);
     	else
      	edited_contact->setPixmap(1, other);
     	edited_contact->setText(2,name);
      edited_contact->setText(3,number);
    }
  }
}

void Leif::deleteContact()
{
  if (connected)
  {
    //set phonebook (sim or phone)
    if (SimRadio->isOn())
    {
      portComm(port, "at+cpbs=\"SM\"\r");
    }
    else
    {
      portComm(port, "at+cpbs=\"ME\"\r");
    }

    QListViewItem *selected = PhonebookList->selectedItem();

    if (selected != 0)
    {
      QString nameMessage = i18n("Delete ");
      nameMessage.append(selected->text(2));
      nameMessage.append(i18n(" from phonebook?"));
      if(KMessageBox::questionYesNo(this, nameMessage, i18n("Delete?")) == 3)
      {
        //Delete entry
        QString command = "at+cpbw=";
        command.append(selected->text(0));
        command.append("\r");
        portComm(port, command);

        //Re-read Phonebook
        readPhoneBook();
      }
    }
  }
}

void Leif::callContact()
{
  if (connected)
  {
    QListViewItem *selected= PhonebookList->selectedItem();

    if (selected != 0)
    {
      QString command = "at*evd=\"";
      command.append(selected->text(3));
      command.append("\"\r");

      portComm(port, command);
    }
  }
}

/* Communication with serial port. Accepts: pointer to used port, string with command to send
    Returns: QStringList containing all lines of answer*/
QStringList Leif::portComm(v24_port_t *port, const QString &command)
{
  int rc;   
  QStringList answer;
  QString temp;
  char ans[80];
  const char *c = command.latin1();

  communicating=true;
  rc=v24Puts(port, c);

  if (rc<strlen(c))
  {
  	 communicating=false;
     KMessageBox::error( this, i18n("Could not write to port"), i18n( "Error" ));
     answer << "err";     
     return answer;
  }
  else
  {
    while((strncmp(ans, "OK", 2) != 0) && (strncmp(ans, "ERROR", 5) != 0))
    {
      rc=v24Gets(port, ans, sizeof(ans)-1);

      if (rc<0)
      {
      	communicating=false;
        KMessageBox::error( this, i18n("Could not read answer"), i18n( "Error" ));
        answer << "err";
        return answer;
      }
      else
      {
      	// scan ans for 0 bytes (used in gsm for @)
       	for (int i=0;i<rc;i++)
        	if (!ans[i])
         		ans[i]=0x80;
      	temp.append(ans);
       	if (temp.right(1)=="\n")
        {
        	answer << temp;
         	temp="";
        }
      }
    }
    communicating = false;
    return answer;
  } 
  
}

void Leif::sendFile()
{
  struct sessiondata session;
  obex_t *handle;
  
  session.client_done = FALSE;
  session.filename = obexLocalFileEdit->text().latin1();

  //Init OBEX
  if (device.contains("ircomm"))
    handle = obexInit(&session, 1, "", 0);
  else if (device.contains("rfcomm"))
  {
    handle = obexInit(&session, 2, addr.latin1(), chann.toInt());
  }
  else
  {
    KMessageBox::error(this, i18n("Cannot determine uploading method. Did you set /dev/ircomm* or /dev/rfcomm* in the settings dialog?"), i18n("Error"));
    return;
  }

  if (!handle)
  {
    KMessageBox::error(this, i18n("Invalid OBEX handle!"), i18n("Error"));
    return;
  }

  if (obexConnect(handle))
  {
    KMessageBox::error(this, i18n("OBEX connection error!"), i18n("Error"));
    return;
  }

  //Put file on phone
  obexPutfile(handle, &session, obexRemoteFileEdit->text().latin1());

  if (obexDisconnect(handle))
  {
    KMessageBox::error(this, i18n("OBEX disconnect error!"), i18n("Error"));
    return;
  }
}

void Leif::browseUploadFile()
{
  obexLocalFileEdit->setText(KFileDialog::getOpenFileName());  
}

void Leif::updateRemoteFileName(const QString &newtext)
{
  if (newtext.contains("/"))
  {
    obexRemoteFileEdit->setText(newtext.right(newtext.length() - newtext.findRev("/") - 1));
  }
  else
  {
    obexRemoteFileEdit->setText(newtext);
  }
}


void Leif::retrieveSMSList()
{
  QStringList sms;
  
  if (connected)
  {  
    portComm(port, "at+cpms=\"ME\"\r");

    // all SMS
    smsList->clear();
    sms = portComm(port, "at+cmgl=4\r");
    createListViewItemForSMS(sms);
  } 
}

void Leif::newSMS()
{
  if (connected)
  {
    NewSMSDlg *nsms = new NewSMSDlg(this);

    QListViewItem *selected= PhonebookList->selectedItem();

    if (tab_2->isVisible() && selected)
    {
      nsms->number->setText(selected->text(3));
      nsms->message->setFocus();
    }
    else
      nsms->number->setFocus();
    nsms->show();
    connect(nsms, SIGNAL(sendPDU(const QString&,int)), this,
    				SLOT(sendSMSFromPDU(const QString&,int)));
  }
}

void Leif::deleteSMS()
{
  QListViewItem *selected = smsList->selectedItem();

  if (selected != 0)
  { 
    if(KMessageBox::questionYesNo(this, i18n("Delete SMS from phone?"), i18n("Delete?")) == 3)
    {
      QString command = "at+cmgd=";
      command.append(selected->text(0));
      command.append("\r");

      portComm(port, command);

      //Re-Read SMS List
      retrieveSMSList();
    }
  }  
}

void Leif::showCompleteSMS(QListViewItem *selected)
{
  QString messageString = i18n("From: ");
 	messageString.append(selected->text(2));
  messageString.append("\n\n");
  messageString.append(selected->text(3));
  messageString.append(i18n("\n\nReply?"));

  if ((KMessageBox::questionYesNo(0, messageString, i18n("SMS"))) == 3)
  {
    NewSMSDlg *rep = new NewSMSDlg(this);
    rep->number->setText(selected->text(4));
    rep->message->setFocus();
    rep->show();
    connect(rep, SIGNAL(sendPDU(const QString&,int)), this, SLOT(sendSMSFromPDU(const QString&,int)));
  }
}

void Leif::sendSMSFromPDU(const QString &PDU, int send)
{
  int stop = 0;
  char buffer[512];
  QString len;
  QString command=send?"at+cmgs=":"at+cmgw=";
      
  len.setNum((PDU.length() / 2) - 1);
  command.append(len);
  command.append("\r");

  communicating=true;
  v24Puts(port, command.latin1());
  while(!stop)
  {
    v24Gets(port, buffer, 512);
    if (strstr(buffer, ">"))
      stop = 1;
    else if (strstr(buffer, "ERROR"))
    {
        stop = 1;
        KMessageBox::error(this, i18n("Could not run SMS service on phone!"), i18n("Error"));
    }
  }

  command = PDU;
  v24Puts(port, command.latin1());
  v24Puts(port, "\x1a");
  v24Gets(port, buffer, 512);
  v24Gets(port, buffer, 512);
  communicating=false;
  if (strstr(buffer, "ERROR"))
    KMessageBox::error(this, i18n("Could not send SMS!"), i18n("Error"));
  else
    KMessageBox::information(this, i18n("SMS successfully sent"), i18n("Information")); 
}

void Leif::savePhonebook()
{
  int m, h, w, o;

  m = mobile.serialNumber();
  h = home.serialNumber();
  w = work.serialNumber();
  o = other.serialNumber();

  if (PhonebookList->childCount() == 0)
  {
    KMessageBox::information(this, i18n("You must load the phonebook from the phone first"));
    return;
  }
  
  QString fileName = KFileDialog::getSaveFileName();

  if (fileName)
  {
    std::ofstream outfl(fileName.latin1());

    QListViewItem *item = PhonebookList->firstChild();
    
    while (item)
    { 
      outfl << item->text(0).latin1() << ":";

      if (item->pixmap(1)->serialNumber() == m)
        outfl << "m";
      else if (item->pixmap(1)->serialNumber() == w)
        outfl << "w";
      else if (item->pixmap(1)->serialNumber() == h)
        outfl << "h";
      else if (item->pixmap(1)->serialNumber() == o)
        outfl << "o";
      
      outfl << ":" << item->text(2).latin1() << ":" << item->text(3).latin1() << "\n";
      item = item->nextSibling();
    }

    KMessageBox::information(this, i18n("Phonebook saved"), i18n("Information"));  
  }
}

void Leif::restorePhonebook()
{
  QString types[200];
  int j=0;
  
  QString fileName = KFileDialog::getOpenFileName();
  
  char buf[255];

  PhonebookList->clear();
  
  if(fileName)
  {
    std::ifstream infl(fileName.latin1());

    while (!infl.eof())
    {
      int pos, pos2;
      infl.getline(buf, 255);

      QString line;
      line.setLatin1(buf);

      QListViewItem *item = new QListViewItem(PhonebookList);

      pos = line.find(":");
      item->setText(0, line.left(pos));
      j = line.left(pos).toInt();

      pos2 = line.find(":", pos+1);

      QString location = line.mid(pos+1, 1);
      types[j] = location.upper();
    

      if (location.contains("m"))
        item->setPixmap(1, mobile);
      else if (location.contains("w"))
        item->setPixmap(1, work);
      else if (location.contains("h"))
        item->setPixmap(1, home);
      else if (location.contains("o"))
        item->setPixmap(1, other);

      pos = line.find(":", pos2+1);
      item->setText(2, line.mid(pos2+1, pos-pos2-1));
      item->setText(3, line.right(line.length()-pos-1));
        
      PhonebookList->insertItem(item);    
    }
  }
  PhonebookList->setSorting(2);
  PhonebookList->sort();
  PhonebookList->takeItem(PhonebookList->lastItem());

  if ((KMessageBox::questionYesNo(this, i18n("Write this phonebook to the phone?\n\nWARNING! All current phonebook entries on your phone will be deleted!"), i18n("Restore?"))) == 3)
  {
    if (connected)
    {
      if (SimRadio->isOn())
      {
        portComm(port, "at+cpbs=\"SM\"\r");
      }
      else
      {
        portComm(port, "at+cpbs=\"ME\"\r");
      }

      //Delete all entries
      int i;
      QString command;
      QString index;
      
      for(i=1;i<=510;i++)
      {
        index.setNum(i);
        command = "at+cpbw=";
        command.append(index);
        command.append(",\"\",,\"\"");
        command.append("\r");

        portComm(port, command);
      }

      //Write new phonebook
      QListViewItem *contact = PhonebookList->firstChild();
      QString idx, name, number, type;

      while(contact)
      {

        idx = contact->text(0);
        name = contact->text(2);
        number = contact->text(3);
        type = types[idx.toInt()];

        createNewContact(idx, name, number, type);

        contact = contact->nextSibling();
      }      
    }
    else
    {
      KMessageBox::error(this, i18n("You are not connected to the phone!"), i18n("Error"));
      PhonebookList->clear();
    }
  }  
  else
  {
     PhonebookList->clear();
  }
}

void Leif::deleteAllSMS()
{
  if (connected)
  {
    if (smsList->childCount() == 0)
    {
      KMessageBox::error(this, i18n("You must first retrieve the SMS list"), i18n("Error"));
      return;
    }
    else
    {
      if(KMessageBox::questionYesNo(this, i18n("This will delete ALL SMS on your phone!\n\nProceed?"), i18n("Warning")) == 3)
      {
        QListViewItem *item = smsList->firstChild();

        while(item)
        {
          QString command = "at+cmgd=";
          command.append(item->text(0));
          command.append("\r");

          portComm(port, command);
    
          item = item->nextSibling();
        }

        retrieveSMSList();
      }
      else
        return;
    }
  }
  else
    KMessageBox::error(this, i18n("You are not connected to the phone!"), i18n("Error"));
}

void Leif::syncDateTime()
{
  QDateTime dateTime = QDateTime::currentDateTime();
  QString dateTimeString = dateTime.toString(Qt::ISODate);

  dateTimeString.replace(QRegExp("-"), "/");
  dateTimeString.replace(QRegExp("T"), ",");
  dateTimeString.remove(0, 2);

  dateTimeString.append("+00\"\r");

  dateTimeString.prepend("AT+CCLK=\"");
  printf("%s\n", dateTimeString.latin1());

  portComm(port, dateTimeString);
}

Leif::~Leif()
{
}
/** No descriptions */
void Leif::editContact(QListViewItem*){
    QListViewItem *selected= PhonebookList->selectedItem();
    if (connected && selected)
    {
      NewContactDlg *newc = new NewContactDlg(this);
      QObject::connect(newc,
                                SIGNAL(sendContact(const QString&,const QString&,
                                									 const QString&,const QString&)),
                                this,
                                SLOT(createNewContact(const QString&,const QString&,
                                										  const QString&,const QString&)));

			newc->editContact(selected->text(2),
												selected->text(3),
												selected->pixmap(1)->serialNumber()==home.serialNumber()? "H":
												selected->pixmap(1)->serialNumber()==mobile.serialNumber()? "M":
												selected->pixmap(1)->serialNumber()==work.serialNumber()? "W":"O",
												selected->text(0));
      newc->show();
    }
}
/** No descriptions */
QString Leif::getNameFromNumber(const QString &number)
{
	QString searchNumber = number.left(1)=="0"? countryCode + number.mid(1) : number;
    QString localNumber;
    
    if(number.left(3).contains(countryCode))
    {  
      localNumber = number.right(number.length()-3);
      localNumber.prepend("0");
      printf("%s\n\n", localNumber.latin1());
    }
	QListViewItem *result=PhonebookList->findItem(number,3);
	if (result)
		return result->text(2);
	if ((result=PhonebookList->findItem(searchNumber,3)))
		return result->text(2);
	if ((result=PhonebookList->findItem(localNumber,3)))
		return result->text(2);
        
	return number;
}
/** No descriptions */
void Leif::editContactButton(){
	QListViewItem *selected = PhonebookList->selectedItem();
	editContact(selected);
}
/** No descriptions */
void Leif::displayIncomingSMS(){
	if (!communicating)
	{
		int i=v24HaveData(port);
		if (i>0)
		{
        printf("v24 Havedata!\n");
			char buffer[80];
			if (v24Read(port,(unsigned char*)buffer,80)<i)
			{
     		  KMessageBox::error( this, i18n("Could not read from queue!"), i18n( "Error" ));
			}
			else
			{
				buffer[i]=0;
				printf("message from mobile phone: %s", buffer);
				QString ans=buffer;
				int i=ans.find("+CMTI:");
				if (i<0)
					printf("message unexpected!\n");
				else
				{
					// get message index
					int start=ans.find(",",i)+1;
					QString index=ans.mid(start);
    			portComm(port, "at+cpms=\"ME\"\r");
					QStringList sms = portComm(port,"at+cmgr="+index);
					createListViewItemForSMS(sms,index.toInt());
				}
			}
		}
	}
}
/** No descriptions */
void Leif::createListViewItemForSMS(const QStringList &sms, int index/*=-1*/){
	QString smsS,id,status,temp;
	int i;
  QPixmap read, unread, sent;
	KIconLoader iconLoader;
	QString cmd=(index==-1)? "+CMGL:" : "+CMGR:";
	
  read = iconLoader.loadIcon("folder_open", KIcon::Small);
  unread = iconLoader.loadIcon("folder_mail", KIcon::Small);
  sent = iconLoader.loadIcon("mail_send", KIcon::Small);
  
  //Read Messages
  for(QStringList::ConstIterator it = sms.begin(); it != sms.end(); ++it)
  {
    smsS.setLatin1(*it);

    if ((i=smsS.find(cmd))>=0)
    {
    	smsS = smsS.mid(i);
     	if (index==-1)
      {
      	id = smsS.mid(7,smsS.find(",")-7);
      	status = smsS.mid(smsS.find(",")+1,1);
      }
      else
      {
      	id.setNum(index);
       	status = smsS.mid(7,smsS.find(",")-7);
      }

      it++;
      smsS.setLatin1(*it);
      SMS *shortMessage = new SMS();
      shortMessage->PDU = smsS;
      shortMessage->parse();
			QString senderName = getNameFromNumber(shortMessage->sender);

      QListViewItem *item = new QListViewItem(smsList, id, "", senderName,
      														shortMessage->message, shortMessage->sender);
      
      if (status.contains("3"))
        item->setPixmap(1, sent);
      if (status.contains("1"))
        item->setPixmap(1, read);
      if (status.contains("0"))
        item->setPixmap(1, unread);

      smsList->insertItem(item);
    	smsList->setColumnWidth(4,0);
      delete shortMessage;
      if (index!=-1)
      	showCompleteSMS(item);
    }
  }
}
/** No descriptions */
void Leif::settingsUpdated(){
  KConfig *settings = kapp->config();
  settings->setGroup("Main");
	device = settings->readEntry("Device");
  int interval= settings->readNumEntry("UpdateInterval");
  if (interval>=1)
  	timer->start( 1000*interval);
  else
  	timer->stop();
  countryCode = settings->readEntry("CountryCode");
  settings->setGroup("Bluetooth");
  addr = settings->readEntry("Address");
  chann = settings->readEntry("OBEX_Channel");

}

void Leif::setSilentMode()
{
  if (connected)
  {
    if(silentCheckBox->isChecked() == true)
      portComm(port, "AT*ESIL=1\r");       
    else
      portComm(port, "AT*ESIL=0\r");
  }
    
}
