/***************************************************************************
                          leif.h  -  description
                             -------------------
    begin                : Wed Mar  5 15:21:47 CET 2003
    copyright            : (C) 2003 by Tobias Bayer
    email                : t.bayer@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LEIF_H
#define LEIF_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <qwidget.h>
#include <qvariant.h>
#include <qpixmap.h>
#include <kmainwindow.h>
#include <ezV24/ezV24.h>
#include "leifobex.h"

class QGridLayout;
class QAction;
class QActionGroup;
class QToolBar;
class KListView;
class KPushButton;
class QLabel;
class QListViewItem;
class QButtonGroup;
class QRadioButton;
class QTabWidget;
class QWidget;
class KProgress;
class KPopupMenu;
class QLineEdit;
class QTimer;
class QCheckBox;

/** Leif is the base class of the project */
class Leif : public KMainWindow
{
  Q_OBJECT 
  public:
    /** construtor */
    Leif(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~Leif();
  /** No descriptions */
  QString getNameFromNumber(const QString&);
  /** No descriptions */
  void createListViewItemForSMS(const QStringList&, int index=-1);


    QTabWidget* MainTab;
    QWidget* tab;
    QLabel* textLabel1_3;
    QLabel* textLabel3_4;
    QLabel* textLabel3_5;
    KProgress* charge;
    KProgress* signal;
    QWidget* tab_2;
    KPushButton* NewButton;
    QButtonGroup* PhoneBookRadios;
    QRadioButton* PhoneRadio;
    QRadioButton* SimRadio;
    KPushButton* ReadButton;
    KPushButton* DeleteButton;
    KPushButton* EditButton;
    KPushButton* CallButton;
    KListView* PhonebookList;
    QWidget* tab_3;
    QWidget* tab_4;
    QLabel* textLabel2;
    QLabel* connectStateLabel;
    KPopupMenu *fileMenu;
    QAction* fileSettingsAction;
    QAction* ConnectAction;
    QAction* DisconnectAction;
    QAction* fileExitAction;
    KPushButton *SavePhonebookButton;
    KPushButton *RestorePhonebookButton;
    KPushButton *newSMSPhonebookButton;

    QCheckBox *silentCheckBox;

    KPushButton *generalRefreshButton;
    KPushButton *syncDateTimeButton;

    QLabel *obexLocalFileLabel;
    QLineEdit *obexLocalFileEdit;
    QLabel *obexRemoteFileLabel;
    QLineEdit *obexRemoteFileEdit;
    KPushButton *obexSendButton;
    KPushButton *obexBrowseFileButton;

    KListView *smsList;
    KPushButton *newSMSButton;
    KPushButton *deleteSMSButton;
    KPushButton *retrieveSMSListButton;
    KPushButton *deleteAllSMSButton;
    QPixmap mobile, home, work, other;
    QTimer *timer, *timer2;
		QString addr, chann, device, countryCode;
		
    public slots:
    void fileConnect();
    void fileDisconnect();
    void fileSettings();
    void fileExit();
    void refreshGeneral();
    void readPhoneBook();
    void newContact();
    void deleteContact();
    void callContact();
    void createNewContact(const QString&, const QString&, const QString&, const QString&);
    void sendFile();
    void browseUploadFile();
    void updateRemoteFileName(const QString&);
    void newSMS();
    void retrieveSMSList();
    void deleteSMS();
    void deleteAllSMS();
    void showCompleteSMS(QListViewItem*);
    void sendSMSFromPDU(const QString&,int);
    void savePhonebook();
    void restorePhonebook();
    void syncDateTime();
  /** No descriptions */
  void editContact(QListViewItem*);
  /** No descriptions */
  /** No descriptions */
  void editContactButton();
  /** No descriptions */
  void displayIncomingSMS();
  /** No descriptions */
  void settingsUpdated();
  void setSilentMode();
                                
    private slots:
    QStringList portComm(v24_port_t*, const QString&);

protected:
    QGridLayout* MainWindowLayout;
    QGridLayout* tabLayout;
    QGridLayout* tabLayout_2;

    QGridLayout* uploadTabLayout;
    QGridLayout* smsTabLayout;
private: // Private attributes
  /**  */
  bool communicating;
};

#endif
