/***************************************************************************
                          leifobex.h  -  description
                             -------------------
    begin                : Don Mr 13 2003
    copyright            : (C) 2003 by Tobias Bayer
    email                : t.bayer@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

extern "C"
{
  #include <openobex/obex.h>
}

enum session_transport
{
  TRANS_NONE,
  TRANS_TCP,
  TRANS_IRDA,
  TRANS_SERIAL
};

enum session_operation
{
   OPERATION_NONE,
   OPERATION_BACKUP,
   OPERATION_SEND
};

enum session_target
{
  TARGET_NONE,
  TARGET_PHONEBOOK,
  TARGET_CAL,
  TARGET_ALL
} ;

struct sessiondata
{
  int connected;
  int client_done;
  enum session_transport transport;
  enum session_operation operation;
  enum session_target target;
  const char *filename;
};

obex_t* obexInit(struct sessiondata *s, int method, const char *address, int channel);
void obexEvent(obex_t *handle, obex_object_t *object, int mode, int event, int obex_cmd, int obex_rsp);
void obexEventDone(obex_t *handle, obex_object_t *object, int obex_cmd, int obex_rsp);
int obexConnect(obex_t *handle);
int obexDisconnect(obex_t *handle);
char* obexPutReadFile(const char *filename, int *length);
int obexPutfile(obex_t *handle, struct sessiondata *s, const char *name);
void syncwait(obex_t *handle);
