/***************************************************************************
                          newcontactdlg.cpp  -  description
                             -------------------
    begin                : Son Mr 9 2003
    copyright            : (C) 2003 by Tobias Bayer
    email                : t.bayer@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "newcontactdlg.h"
#include <klocale.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <kpushbutton.h>
#include <qcombobox.h>
#include <qpixmap.h>
#include <kiconloader.h>

NewContactDlg::NewContactDlg(QWidget *parent, const char *name) : QWidget(0L, name)
{
  this->setCaption(i18n("New Contact"));

  grid = new QGridLayout(this,1,1,11,6);

  label1 = new QLabel(this);
  label1->setText(i18n("Name:"));

  nameEdit = new QLineEdit(this);  

  label2 = new QLabel(this);
  label2->setText(i18n("Number:"));

  numberEdit = new QLineEdit(this);

  label3 = new QLabel(this);
  label3->setText(i18n("Type:"));

  type = new QComboBox(this);
  type->insertItem(i18n("Mobile"));
  type->insertItem(i18n("Home"));
  type->insertItem(i18n("Work"));
  type->insertItem(i18n("Other"));

  grid->addWidget(label1,0,0);
  grid->addWidget(nameEdit,0,1);
  grid->addWidget(label2,1,0);
  grid->addWidget(numberEdit,1,1);
  grid->addWidget(label3,2,0);
  grid->addWidget(type, 2,1);

  okButton = new KPushButton(this);
  okButton->setText(i18n("&OK"));
  okButton->setGeometry(QRect(10,50,80,30));

  cancelButton = new KPushButton(this);
  cancelButton->setText(i18n("&Cancel"));
  cancelButton->setGeometry(QRect(100,50,80,30));

  grid->addWidget(okButton, 3, 0);
  grid->addWidget(cancelButton, 3, 1);

  connect(okButton, SIGNAL(clicked()), this, SLOT(insertContact()));
  connect(cancelButton, SIGNAL(clicked()), this, SLOT(cancelContact()));
}


void NewContactDlg::insertContact()
{
  QString t;
  if (type->currentText() == "Home")
    t = "H";
  else if (type->currentText() == "Mobile")
    t = "M";
  else if (type->currentText() == "Work")
    t = "W";
  else
    t = "O";
    
  emit sendContact(index, nameEdit->text(), numberEdit->text(), t);

  this->close();
}

void NewContactDlg::cancelContact()
{
  this->close();
}

NewContactDlg::~NewContactDlg()
{
}
/** No descriptions */
void NewContactDlg::editContact(const QString& name, const QString& number,
																const QString& typ, const QString& ind){

	setCaption(i18n("Edit Contact"));
	nameEdit->setText(name);
	numberEdit->setText(number);
	if (typ=="M")
		type->setCurrentItem(0);
	else if (typ=="H")
		type->setCurrentItem(1);
	else if (typ=="W")
		type->setCurrentItem(2);
	else
		type->setCurrentItem(3);
	index = ind;
}
