/***************************************************************************
                          newsms.cpp  -  description
                             -------------------
    begin                : Mit Mr 19 2003
    copyright            : (C) 2003 by Tobias Bayer
    email                : t.bayer@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "newsms.h"
#include "sms.h"
#include <klocale.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <kpushbutton.h>
#include <qtextedit.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>

NewSMSDlg::NewSMSDlg(QWidget *parent, const char *name) : QWidget(0L, name)
{
  this->setCaption(i18n("New SMS"));

  layout = new QGridLayout(this,1,1,11,6);

  NewSMSRadios = new QButtonGroup(this);
  NewSMSRadios->hide();

  SendRadio = new QRadioButton( this, "SendRadio" );
  SendRadio->setChecked( TRUE );

  layout->addWidget( SendRadio, 3, 0 );

  WriteRadio = new QRadioButton( this, "WriteRadio" );

  layout->addWidget( WriteRadio, 3, 1 );

  NewSMSRadios->insert(SendRadio);
  NewSMSRadios->insert(WriteRadio);

  label1 = new QLabel(this);
  label1->setText(i18n("To:"));

  number = new QLineEdit(this);

  label2 = new QLabel(this);
  label2->setText(i18n("Message:"));

  remain = new QLabel(this);
  remain->setText("160");

  message = new QTextEdit(this);

  sendSMSButton = new KPushButton(this);
  sendSMSButton->setText(i18n("&Send"));

  cancelSMSButton = new KPushButton(this);
  cancelSMSButton->setText(i18n("&Cancel"));

  layout->addWidget(label1,1,0);
  layout->addWidget(number,1,1);
  layout->addWidget(label2,2,0);
  layout->addWidget(message,2,1);
  layout->addWidget(remain, 2, 2);
  layout->addWidget(sendSMSButton,4,0);
  layout->addWidget(cancelSMSButton, 4,1);


  connect(sendSMSButton, SIGNAL(clicked()), this, SLOT(sendNewSMS()));
  connect(cancelSMSButton, SIGNAL(clicked()), this, SLOT(cancelNewSMS()));
  connect(message, SIGNAL(textChanged()), this, SLOT(updateRemaining()));

  SendRadio->setText(i18n("Send message"));
  WriteRadio->setText(i18n("Transfer to phone only"));
}

void NewSMSDlg::cancelNewSMS()
{
  this->close();
}

void NewSMSDlg::sendNewSMS()
{
  SMS *sms = new SMS();
  sms->recipient=number->text();
  sms->message=message->text();
  int chars=message->text().length();
  int numSMS=chars<160?1:chars/153;
  if (chars%153 && chars>160)
  	numSMS++;
  int rand_id=(int) (256.0*rand()/(RAND_MAX+1.0));
	for (int i=1;i<=numSMS;i++)
	{  
  	sms->createSendPDU(i,rand_id);
  	emit sendPDU(sms->PDU,SendRadio->isOn());
  }
  delete sms;
}

void NewSMSDlg::updateRemaining()
{
	QString temp,temp2;
  int chars=message->text().length();
  int numSMS=chars<160?1:chars/153;
  if (chars%153 && chars>160)
  	numSMS++;
  temp.setNum(chars);
  temp2.setNum(numSMS);
  remain->setText(temp + "/" + temp2);
}

NewSMSDlg::~NewSMSDlg()
{
}
